;; one
;; two
;; three

(setq test-beg 1
      test-end 23)
(setq test-overlay (make-overlay test-beg test-end))
(setq test-buffer nil)
(setq test-parent-buffer (current-buffer))

(defun test-create-indirect ()
  (setq test-buffer (generate-new-buffer "*test*"))
  (with-current-buffer test-buffer
    (insert-buffer-substring-no-properties test-parent-buffer test-beg test-end)
    (set-buffer-modified-p nil)))

(defun test-commit-indirect ()
  (let ((beg (overlay-start test-overlay))
        (end (overlay-end test-overlay)))
    (with-current-buffer (overlay-buffer test-overlay)
      (let ((beg-marker (copy-marker beg))
            (end-marker (copy-marker end)))
        (set-match-data (list beg-marker end-marker))
        (let ((new-data
               (with-current-buffer test-buffer
                 (buffer-substring-no-properties 1 (1+ (buffer-size))))))
          (message "new: %s" new-data)
          (replace-match new-data t t))))))

;; Eval the above then execute (test-create-indirect) which will create an indirect buffer of
;; the first 3 lines and name it "*test*".
;;
;; Switch to the *test* buffer and change the middle line to "two - 1".  Execute
;; (test-commit-indirect) to save the change back to this file.
;;
;; With 69121c33e4a, the commit before feature/noverlay, (test-commit-indirect) simply replaces
;; the original text:
;;
;;     one
;;     two - 1
;;     three
;;
;; With b7a76f288cc, which was master when I pulled yesterday, new lines are inserted above the
;; original 3:
;;
;;     one
;;     two - 1
;;     three
;;     one
;;     two
;;     three
